
import uploader from '@/plugins/uploader/index.js'

export default {
    /**
     * 执行任务队列
     */
    async uploadImageTask(that) {
        const uploadTask = that.uploadTask

        const options = {
            files: uploadTask, // 必填 临时文件路径 格式: [{path: "图片地址"}]
            load: false, //（默认 true 说明：本接口是否提示加载动画）
            onEachUpdate: res => {
                console.log("上传成功返回：",res);
            },
            Update: res => {
                console.log("上传进度返回：",res);
            }
        }

        uploader.qnFileUpload(options).then(res => {
            this.refreshTask(that, res)
        }).catch(err => {
            console.log("err", err)
            if (err.errMsg.indexOf('fail file not found') !== -1) { // 在任务中删除不存在的图片
                this.refreshTask(that, ['failErr'])
            }
        })
    },
    refreshTask(that, result) {
        const uploadTask = that.uploadTask
        let newTask = [] 
        let delImg = [] 
        uploadTask.forEach(v => {
            if (result.includes(`/${v.key}`) || result.includes('failErr')) { // 删除已上传的图片
                delImg.push(v.path)
            } else { // 未上传的重新存储
                newTask.push(v)
            }
        })

        // uni.setStorageSync('delImg', delImg) // 已上传完的图片，会在启动系统的时候做一次清理
        that.$u.vuex('uploadTask', newTask)
    }
}